﻿using GraphicsManager.Objects.Core;
using OpenTK.Mathematics;
using OpenTK.Windowing.Common;
using OpenTK.Windowing.Common.Input;

namespace GraphicsManager.Interfaces;

public interface IParent
{
	public Vector2 LocationAsFloat { get; }
	public ControlList Controls { get; }
	public IParent? Parent { get; }
	public Vector2i Size { get; }
	public void ParentResize();
	public float IntToWindow(float p, bool Y = false);
	public void TryDraw(int depth = 0);
	public void ReportSizeUpdate(IRenderObject Control);
	public Vector2i Position { get; }
	public MouseCursor HoverMouse { get; set; }
	public int LastX { get; }
	public int LastY { get; }
	public int LastSX { get; }
	public int LastSY { get; }
	public int LastSW { get; }
	public int LastSH { get; }
	public bool BlockDraw { get; set; }
	public bool IgnoreVisForChildren { get; set; }
	public void ResizeDraw(int x, int y, int sx, int sy, int sw, int sh);
	public int OldWidth { get; }
	public int OldHeight { get; }
	
	public bool CollectUpperFiles { get; set; }
}
